// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

// tslint:disable
/**
 * eGesetzgebung Platform
 * This is the rest interface offered by the eGesetzgebung Platform backend.  Please provide __JW Access Token__ using button \'Authorize\' to access protected endpoints. Use the following instructions to get token:  1. on CMD/Bash/Terminal: ```curl -d \"client_id=user-management\" -d \"client_secret=INSERT_IAM_SECRET\" -d \"grant_type=password&username=INSERT_USER_EMAIL&password=INSERT_USER_PASSWORD\" \"INSERT_IAM_URL/realms/bund/protocol/openid-connect/token\"``` 2. copy access_token (without quotes, you can use jq or other tools to extract this value automatically) 3. insert value into \'JWToken\' field under \'Authorize\' and press \'Authorize\' 4. now you should have access to user protected endpoint  __FYI:__ token expires after 60 seconds. On non-production systems only a warning is displayed so you can work smoothly, but on production systems you have to frequently provide a new token.
 *
 * The version of the OpenAPI document: 9.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import type { Observable } from 'rxjs';
import type { AjaxResponse } from 'rxjs/ajax';
import { BaseAPI, throwIfNullOrUndefined, encodeURI } from '../runtime';
import type { OperationOpts, HttpHeaders } from '../runtime';
import type {
    GetKalender200ResponseInner,
    PaginierungDTO,
    PhaseEntityDTO,
    TerminEntityDTO,
    ZeitplanungArchivTableDTOs,
    ZeitplanungBilligungAnfrageDTO,
    ZeitplanungBilligungAntwortDTO,
    ZeitplanungBilligungTableDTOs,
    ZeitplanungEntityResponseDTO,
    ZeitplanungEntityResponseShortDTO,
    ZeitplanungEntityShortDTO,
    ZeitplanungKommentarCreateRequestDTO,
    ZeitplanungKommentarEntityListResponseDTO,
    ZeitplanungKommentarModifyRequestDTO,
    ZeitplanungTableDTOs,
    ZeitplanungselementEntityDTO,
    ZeitplanungsvorlageEntityResponseShortDTO,
    ZeitplanungsvorlageEntityShortDTO,
} from '../models';

export interface AddDateToZeitplanungRequest {
    id: string;
    terminEntityDTO: TerminEntityDTO;
}

export interface AddPhaseToZeitplanungRequest {
    id: string;
    phaseEntityDTO: PhaseEntityDTO;
}

export interface ArchiveBilligungsanfrageRequest {
    billigungId: string;
}

export interface ArchiveZeitplanungRequest {
    id: string;
}

export interface CancelBilligungsanfrageRequest {
    billigungId: string;
}

export interface CreateZeitplanungRequest {
    zeitplanungEntityShortDTO: ZeitplanungEntityShortDTO;
}

export interface CreateZeitplanungsvorlage1Request {
    zeitplanungsvorlageEntityShortDTO: ZeitplanungsvorlageEntityShortDTO;
}

export interface CreateZpKommentarRequest {
    zeitplanungId: string;
    zeitplanungKommentarCreateRequestDTO: ZeitplanungKommentarCreateRequestDTO;
}

export interface DeleteZeitplanungselementFromZeitplanungRequest {
    elementId: string;
    zeitplanungAnpassen: boolean;
}

export interface DeleteZpKommentarRequest {
    kommentarId: string;
}

export interface GetMeineZeitplanungenRequest {
    isFilterNeeded: boolean;
    paginierungDTO: PaginierungDTO;
}

export interface GetZeitplanungRequest {
    id: string;
}

export interface GetZeitplanungenArchivRequest {
    isFilterNeeded: boolean;
    paginierungDTO: PaginierungDTO;
}

export interface GetZeitplanungenBilligungenRequest {
    isFilterNeeded: boolean;
    paginierungDTO: PaginierungDTO;
}

export interface GetZpKommentareRequest {
    zeitplanungId: string;
}

export interface ModifyDateInZeitplanungRequest {
    elementId: string;
    terminEntityDTO: TerminEntityDTO;
}

export interface ModifyPhaseInZeitplanungRequest {
    elementId: string;
    phaseEntityDTO: PhaseEntityDTO;
}

export interface ModifyZpKommentarRequest {
    kommentarId: string;
    zeitplanungKommentarModifyRequestDTO: ZeitplanungKommentarModifyRequestDTO;
}

export interface ReplyToBilligungsanfrageRequest {
    billigungId: string;
    zeitplanungBilligungAntwortDTO: ZeitplanungBilligungAntwortDTO;
}

export interface RequestBilligungRequest {
    zeitplanungId: string;
    zeitplanungBilligungAnfrageDTO: ZeitplanungBilligungAnfrageDTO;
}

/**
 * no description
 */
export class ZeitplanungControllerApi extends BaseAPI {

    /**
     * Fügt einer Zeitplanung einen neuen Termin hinzu
     * POST ZEITPLANUNG DATE
     */
    addDateToZeitplanung({ id, terminEntityDTO }: AddDateToZeitplanungRequest): Observable<void>
    addDateToZeitplanung({ id, terminEntityDTO }: AddDateToZeitplanungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    addDateToZeitplanung({ id, terminEntityDTO }: AddDateToZeitplanungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'addDateToZeitplanung');
        throwIfNullOrUndefined(terminEntityDTO, 'terminEntityDTO', 'addDateToZeitplanung');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/zeitplanung/{id}/date'.replace('{id}', encodeURI(id)),
            method: 'POST',
            headers,
            body: terminEntityDTO,
        }, opts?.responseOpts);
    };

    /**
     * Fügt einer Zeitplanung eine neue Phase hinzu
     * POST ZEITPLANUNG PHASE
     */
    addPhaseToZeitplanung({ id, phaseEntityDTO }: AddPhaseToZeitplanungRequest): Observable<void>
    addPhaseToZeitplanung({ id, phaseEntityDTO }: AddPhaseToZeitplanungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    addPhaseToZeitplanung({ id, phaseEntityDTO }: AddPhaseToZeitplanungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'addPhaseToZeitplanung');
        throwIfNullOrUndefined(phaseEntityDTO, 'phaseEntityDTO', 'addPhaseToZeitplanung');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/zeitplanung/{id}/phase'.replace('{id}', encodeURI(id)),
            method: 'POST',
            headers,
            body: phaseEntityDTO,
        }, opts?.responseOpts);
    };

    /**
     * Archiviert eine Billigungsanfrage
     * Billigungsanfrage archivieren
     */
    archiveBilligungsanfrage({ billigungId }: ArchiveBilligungsanfrageRequest): Observable<void>
    archiveBilligungsanfrage({ billigungId }: ArchiveBilligungsanfrageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    archiveBilligungsanfrage({ billigungId }: ArchiveBilligungsanfrageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(billigungId, 'billigungId', 'archiveBilligungsanfrage');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/zeitplanung/zeichnung/{billigungId}/archivieren'.replace('{billigungId}', encodeURI(billigungId)),
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Archiviert eine Zeitplanung
     * Zeitplanung archivieren (E+T)
     */
    archiveZeitplanung({ id }: ArchiveZeitplanungRequest): Observable<void>
    archiveZeitplanung({ id }: ArchiveZeitplanungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    archiveZeitplanung({ id }: ArchiveZeitplanungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'archiveZeitplanung');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/zeitplanung/{id}/archivieren'.replace('{id}', encodeURI(id)),
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Zieht die Billigungsanfrage einer Zeitplanung zurück
     * Billigungsanfrage zurückziehen
     */
    cancelBilligungsanfrage({ billigungId }: CancelBilligungsanfrageRequest): Observable<void>
    cancelBilligungsanfrage({ billigungId }: CancelBilligungsanfrageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    cancelBilligungsanfrage({ billigungId }: CancelBilligungsanfrageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(billigungId, 'billigungId', 'cancelBilligungsanfrage');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/zeitplanung/zeichnung/{billigungId}/cancel'.replace('{billigungId}', encodeURI(billigungId)),
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Legt eine neue Zeitplanung an
     * POST ZEITPLANUNG
     */
    createZeitplanung({ zeitplanungEntityShortDTO }: CreateZeitplanungRequest): Observable<ZeitplanungEntityResponseShortDTO>
    createZeitplanung({ zeitplanungEntityShortDTO }: CreateZeitplanungRequest, opts?: OperationOpts): Observable<AjaxResponse<ZeitplanungEntityResponseShortDTO>>
    createZeitplanung({ zeitplanungEntityShortDTO }: CreateZeitplanungRequest, opts?: OperationOpts): Observable<ZeitplanungEntityResponseShortDTO | AjaxResponse<ZeitplanungEntityResponseShortDTO>> {
        throwIfNullOrUndefined(zeitplanungEntityShortDTO, 'zeitplanungEntityShortDTO', 'createZeitplanung');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<ZeitplanungEntityResponseShortDTO>({
            url: '/zeitplanung',
            method: 'POST',
            headers,
            body: zeitplanungEntityShortDTO,
        }, opts?.responseOpts);
    };

    /**
     * Legt eine neue Zeitplanungsvorlage an
     * POST ZEITPLANUNGSVORLAGE
     */
    createZeitplanungsvorlage1({ zeitplanungsvorlageEntityShortDTO }: CreateZeitplanungsvorlage1Request): Observable<ZeitplanungsvorlageEntityResponseShortDTO>
    createZeitplanungsvorlage1({ zeitplanungsvorlageEntityShortDTO }: CreateZeitplanungsvorlage1Request, opts?: OperationOpts): Observable<AjaxResponse<ZeitplanungsvorlageEntityResponseShortDTO>>
    createZeitplanungsvorlage1({ zeitplanungsvorlageEntityShortDTO }: CreateZeitplanungsvorlage1Request, opts?: OperationOpts): Observable<ZeitplanungsvorlageEntityResponseShortDTO | AjaxResponse<ZeitplanungsvorlageEntityResponseShortDTO>> {
        throwIfNullOrUndefined(zeitplanungsvorlageEntityShortDTO, 'zeitplanungsvorlageEntityShortDTO', 'createZeitplanungsvorlage1');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<ZeitplanungsvorlageEntityResponseShortDTO>({
            url: '/zeitplanung/zeitplanungsvorlage',
            method: 'POST',
            headers,
            body: zeitplanungsvorlageEntityShortDTO,
        }, opts?.responseOpts);
    };

    /**
     * Legt einen Kommentar an
     * POST KOMMENTAR
     */
    createZpKommentar({ zeitplanungId, zeitplanungKommentarCreateRequestDTO }: CreateZpKommentarRequest): Observable<void>
    createZpKommentar({ zeitplanungId, zeitplanungKommentarCreateRequestDTO }: CreateZpKommentarRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    createZpKommentar({ zeitplanungId, zeitplanungKommentarCreateRequestDTO }: CreateZpKommentarRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(zeitplanungId, 'zeitplanungId', 'createZpKommentar');
        throwIfNullOrUndefined(zeitplanungKommentarCreateRequestDTO, 'zeitplanungKommentarCreateRequestDTO', 'createZpKommentar');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/zeitplanung/kommentar/{zeitplanungId}'.replace('{zeitplanungId}', encodeURI(zeitplanungId)),
            method: 'POST',
            headers,
            body: zeitplanungKommentarCreateRequestDTO,
        }, opts?.responseOpts);
    };

    /**
     * Löscht eine Phase oder einen Termin aus der Zeitplanung
     * DELETE ZEITPLANUNG PHASE/DATE
     */
    deleteZeitplanungselementFromZeitplanung({ elementId, zeitplanungAnpassen }: DeleteZeitplanungselementFromZeitplanungRequest): Observable<void>
    deleteZeitplanungselementFromZeitplanung({ elementId, zeitplanungAnpassen }: DeleteZeitplanungselementFromZeitplanungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    deleteZeitplanungselementFromZeitplanung({ elementId, zeitplanungAnpassen }: DeleteZeitplanungselementFromZeitplanungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(elementId, 'elementId', 'deleteZeitplanungselementFromZeitplanung');
        throwIfNullOrUndefined(zeitplanungAnpassen, 'zeitplanungAnpassen', 'deleteZeitplanungselementFromZeitplanung');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/zeitplanung/element/{elementId}/{zeitplanungAnpassen}'.replace('{elementId}', encodeURI(elementId)).replace('{zeitplanungAnpassen}', encodeURI(zeitplanungAnpassen)),
            method: 'DELETE',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Löscht einen Kommentar
     * DELETE KOMMENTAR
     */
    deleteZpKommentar({ kommentarId }: DeleteZpKommentarRequest): Observable<void>
    deleteZpKommentar({ kommentarId }: DeleteZpKommentarRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    deleteZpKommentar({ kommentarId }: DeleteZpKommentarRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(kommentarId, 'kommentarId', 'deleteZpKommentar');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/zeitplanung/kommentar/{kommentarId}'.replace('{kommentarId}', encodeURI(kommentarId)),
            method: 'DELETE',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Kalender des Anwenders ab
     * GET KALENDER LIST FOR USER
     */
    getKalender(): Observable<Array<GetKalender200ResponseInner>>
    getKalender(opts?: OperationOpts): Observable<AjaxResponse<Array<GetKalender200ResponseInner>>>
    getKalender(opts?: OperationOpts): Observable<Array<GetKalender200ResponseInner> | AjaxResponse<Array<GetKalender200ResponseInner>>> {
        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Array<GetKalender200ResponseInner>>({
            url: '/zeitplanung/kalender',
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der Zeitplanungen des Anwenders ab (»Meine Zeitplanungen«)
     * GET ZEITPLANUNGEN LIST FOR USER
     */
    getMeineZeitplanungen({ isFilterNeeded, paginierungDTO }: GetMeineZeitplanungenRequest): Observable<ZeitplanungTableDTOs>
    getMeineZeitplanungen({ isFilterNeeded, paginierungDTO }: GetMeineZeitplanungenRequest, opts?: OperationOpts): Observable<AjaxResponse<ZeitplanungTableDTOs>>
    getMeineZeitplanungen({ isFilterNeeded, paginierungDTO }: GetMeineZeitplanungenRequest, opts?: OperationOpts): Observable<ZeitplanungTableDTOs | AjaxResponse<ZeitplanungTableDTOs>> {
        throwIfNullOrUndefined(isFilterNeeded, 'isFilterNeeded', 'getMeineZeitplanungen');
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getMeineZeitplanungen');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<ZeitplanungTableDTOs>({
            url: '/zeitplanung/zeitplanungen/{isFilterNeeded}'.replace('{isFilterNeeded}', encodeURI(isFilterNeeded)),
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Lädt eine Zeitplanung
     * GET ZEITPLANUNG
     */
    getZeitplanung({ id }: GetZeitplanungRequest): Observable<ZeitplanungEntityResponseDTO>
    getZeitplanung({ id }: GetZeitplanungRequest, opts?: OperationOpts): Observable<AjaxResponse<ZeitplanungEntityResponseDTO>>
    getZeitplanung({ id }: GetZeitplanungRequest, opts?: OperationOpts): Observable<ZeitplanungEntityResponseDTO | AjaxResponse<ZeitplanungEntityResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'getZeitplanung');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<ZeitplanungEntityResponseDTO>({
            url: '/zeitplanung/{id}'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der archivierten Zeitplanungen/Zeitplanungsvorlagen des Anwenders ab (»Archiv«)
     * GET ZEITPLANUNGEN(SVORLAGEN) LIST FOR USER
     */
    getZeitplanungenArchiv({ isFilterNeeded, paginierungDTO }: GetZeitplanungenArchivRequest): Observable<ZeitplanungArchivTableDTOs>
    getZeitplanungenArchiv({ isFilterNeeded, paginierungDTO }: GetZeitplanungenArchivRequest, opts?: OperationOpts): Observable<AjaxResponse<ZeitplanungArchivTableDTOs>>
    getZeitplanungenArchiv({ isFilterNeeded, paginierungDTO }: GetZeitplanungenArchivRequest, opts?: OperationOpts): Observable<ZeitplanungArchivTableDTOs | AjaxResponse<ZeitplanungArchivTableDTOs>> {
        throwIfNullOrUndefined(isFilterNeeded, 'isFilterNeeded', 'getZeitplanungenArchiv');
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getZeitplanungenArchiv');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<ZeitplanungArchivTableDTOs>({
            url: '/zeitplanung/zeitplanungen-archiv/{isFilterNeeded}'.replace('{isFilterNeeded}', encodeURI(isFilterNeeded)),
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der Billigungen (»Billigungen«)
     * GET ZEITPLANUNGEN BILLIGUNGEN LIST FOR USER
     */
    getZeitplanungenBilligungen({ isFilterNeeded, paginierungDTO }: GetZeitplanungenBilligungenRequest): Observable<ZeitplanungBilligungTableDTOs>
    getZeitplanungenBilligungen({ isFilterNeeded, paginierungDTO }: GetZeitplanungenBilligungenRequest, opts?: OperationOpts): Observable<AjaxResponse<ZeitplanungBilligungTableDTOs>>
    getZeitplanungenBilligungen({ isFilterNeeded, paginierungDTO }: GetZeitplanungenBilligungenRequest, opts?: OperationOpts): Observable<ZeitplanungBilligungTableDTOs | AjaxResponse<ZeitplanungBilligungTableDTOs>> {
        throwIfNullOrUndefined(isFilterNeeded, 'isFilterNeeded', 'getZeitplanungenBilligungen');
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getZeitplanungenBilligungen');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<ZeitplanungBilligungTableDTOs>({
            url: '/zeitplanung/zeitplanungen-mitzeichnung/{isFilterNeeded}'.replace('{isFilterNeeded}', encodeURI(isFilterNeeded)),
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Lädt die Kommentare einer Zeitplanung
     * GET KOMMENTARE
     */
    getZpKommentare({ zeitplanungId }: GetZpKommentareRequest): Observable<ZeitplanungKommentarEntityListResponseDTO>
    getZpKommentare({ zeitplanungId }: GetZpKommentareRequest, opts?: OperationOpts): Observable<AjaxResponse<ZeitplanungKommentarEntityListResponseDTO>>
    getZpKommentare({ zeitplanungId }: GetZpKommentareRequest, opts?: OperationOpts): Observable<ZeitplanungKommentarEntityListResponseDTO | AjaxResponse<ZeitplanungKommentarEntityListResponseDTO>> {
        throwIfNullOrUndefined(zeitplanungId, 'zeitplanungId', 'getZpKommentare');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<ZeitplanungKommentarEntityListResponseDTO>({
            url: '/zeitplanung/kommentare/{zeitplanungId}'.replace('{zeitplanungId}', encodeURI(zeitplanungId)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ändert einen Termin
     * PUT ZEITPLANUNG DATE
     */
    modifyDateInZeitplanung({ elementId, terminEntityDTO }: ModifyDateInZeitplanungRequest): Observable<void>
    modifyDateInZeitplanung({ elementId, terminEntityDTO }: ModifyDateInZeitplanungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    modifyDateInZeitplanung({ elementId, terminEntityDTO }: ModifyDateInZeitplanungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(elementId, 'elementId', 'modifyDateInZeitplanung');
        throwIfNullOrUndefined(terminEntityDTO, 'terminEntityDTO', 'modifyDateInZeitplanung');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/zeitplanung/date/{elementId}'.replace('{elementId}', encodeURI(elementId)),
            method: 'PUT',
            headers,
            body: terminEntityDTO,
        }, opts?.responseOpts);
    };

    /**
     * Ändert eine Phase
     * PUT ZEITPLANUNG PHASE
     */
    modifyPhaseInZeitplanung({ elementId, phaseEntityDTO }: ModifyPhaseInZeitplanungRequest): Observable<void>
    modifyPhaseInZeitplanung({ elementId, phaseEntityDTO }: ModifyPhaseInZeitplanungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    modifyPhaseInZeitplanung({ elementId, phaseEntityDTO }: ModifyPhaseInZeitplanungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(elementId, 'elementId', 'modifyPhaseInZeitplanung');
        throwIfNullOrUndefined(phaseEntityDTO, 'phaseEntityDTO', 'modifyPhaseInZeitplanung');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/zeitplanung/phase/{elementId}'.replace('{elementId}', encodeURI(elementId)),
            method: 'PUT',
            headers,
            body: phaseEntityDTO,
        }, opts?.responseOpts);
    };

    /**
     * Ändert einen Kommentar
     * PUT KOMMENTAR
     */
    modifyZpKommentar({ kommentarId, zeitplanungKommentarModifyRequestDTO }: ModifyZpKommentarRequest): Observable<void>
    modifyZpKommentar({ kommentarId, zeitplanungKommentarModifyRequestDTO }: ModifyZpKommentarRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    modifyZpKommentar({ kommentarId, zeitplanungKommentarModifyRequestDTO }: ModifyZpKommentarRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(kommentarId, 'kommentarId', 'modifyZpKommentar');
        throwIfNullOrUndefined(zeitplanungKommentarModifyRequestDTO, 'zeitplanungKommentarModifyRequestDTO', 'modifyZpKommentar');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/zeitplanung/kommentar/{kommentarId}'.replace('{kommentarId}', encodeURI(kommentarId)),
            method: 'PUT',
            headers,
            body: zeitplanungKommentarModifyRequestDTO,
        }, opts?.responseOpts);
    };

    /**
     * Beantwortet eine Billigungsanfrage
     * POST REPLY TO BILLIGUNGSANFRAGE
     */
    replyToBilligungsanfrage({ billigungId, zeitplanungBilligungAntwortDTO }: ReplyToBilligungsanfrageRequest): Observable<void>
    replyToBilligungsanfrage({ billigungId, zeitplanungBilligungAntwortDTO }: ReplyToBilligungsanfrageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    replyToBilligungsanfrage({ billigungId, zeitplanungBilligungAntwortDTO }: ReplyToBilligungsanfrageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(billigungId, 'billigungId', 'replyToBilligungsanfrage');
        throwIfNullOrUndefined(zeitplanungBilligungAntwortDTO, 'zeitplanungBilligungAntwortDTO', 'replyToBilligungsanfrage');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/zeitplanung/zeichnung/antwort/{billigungId}'.replace('{billigungId}', encodeURI(billigungId)),
            method: 'POST',
            headers,
            body: zeitplanungBilligungAntwortDTO,
        }, opts?.responseOpts);
    };

    /**
     * Leitet eine billigungsanfrage ein
     * POST BILLIGUNGSANFRAGE
     */
    requestBilligung({ zeitplanungId, zeitplanungBilligungAnfrageDTO }: RequestBilligungRequest): Observable<void>
    requestBilligung({ zeitplanungId, zeitplanungBilligungAnfrageDTO }: RequestBilligungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    requestBilligung({ zeitplanungId, zeitplanungBilligungAnfrageDTO }: RequestBilligungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(zeitplanungId, 'zeitplanungId', 'requestBilligung');
        throwIfNullOrUndefined(zeitplanungBilligungAnfrageDTO, 'zeitplanungBilligungAnfrageDTO', 'requestBilligung');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/zeitplanung/zeichnung/{zeitplanungId}'.replace('{zeitplanungId}', encodeURI(zeitplanungId)),
            method: 'POST',
            headers,
            body: zeitplanungBilligungAnfrageDTO,
        }, opts?.responseOpts);
    };

}
